// This GUI file is generated by guibuilder version 1.0
function sciIdent(handles)

//clear;
f=figure('position',[0 50 640 480],'units','pixels');
handles.dummy = 0;
handles.pb_input=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','edit','string','U','position',[0.1375,0.9,0.16,0.05]);
handles.pb_Output=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','edit','string','Y','position',[0.1375,0.82,0.16,0.05]);
handles.edit_Ts=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','edit','string','0.002','position',[0.1375,0.74,0.16,0.05]);
handles.edit_Order=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','edit','string','2','position',[0.1375,0.66,0.16,0.05]);

handles.txt_R=uicontrol(f,'unit','normalized','style','text','string','Reference:','position',[0.015,0.9,0.1,0.05]);
handles.txt_Y=uicontrol(f,'unit','normalized','style','text','string','Output:','position',[0.015,0.82,0.1,0.05]);
handles.txt_Ts=uicontrol(f,'unit','normalized','style','text','string','Sampling:','position',[0.015,0.74,0.10,0.05]) ;
handles.txt_Order=uicontrol(f,'unit','normalized','style','text','string','Order:','position',[0.015,0.66,0.1,0.05]);

handles.Axes1= newaxes();handles.Axes1.margins = [ 0 0 0 0];handles.Axes1.axes_bounds = [0.38,0.042,0.6,0.4];
handles.Axes2= newaxes();handles.Axes2.margins = [ 0 0 0 0];handles.Axes2.axes_bounds = [0.38,0.52,0.6,0.4];

handles.txt_Result1=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','BackgroundColor',[1 1 1],'style','list','string','z-Domain','position',[0.025,0.4,0.3,0.12]);
handles.txt_Result2=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','BackgroundColor',[1 1 1],'style','list','string','s-Domain','position',[0.025,0.25,0.3,0.12]);

handles.pb_Load=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','pushbutton','string','Load Data','position',[0.04375,0.58,0.23125,0.0666667],'callback','pb_Load_callback(handles)');

handles.pb_Calc=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','pushbutton','string','Identification','position',[0.04375,0.15,0.23125,0.0666667],'callback','pb_Calc_callback(handles)');

handles.pb_Export=uicontrol(f,'unit','normalized','FontSize',12,'FontWeight','bold','style','pushbutton','string','Export','position',[0.04375,0.05,0.23125,0.0666667],'callback','pb_Export_callback(handles)');
handles = resume(handles);
endfunction

//////////
// Callbacks are defined as below. Please do not delete the comments as it will be used in coming version
//////////


function pb_Load_callback(handles)
//Write your callback for  pb_Calc  here

sca(handles.Axes1);
U = evstr(get(handles.pb_input,'string'));
Y = evstr(get(handles.pb_Output,'string'));
Ts = evstr(get(handles.edit_Ts,'string'));
t = 0:Ts:(length(U)-1)*Ts;
plot(t,U,t,Y);

endfunction


function pb_Calc_callback(handles)
//Write your callback for  pb_Calc  here
sca(handles.Axes2);
S = 5;
N = eval(get(handles.edit_Order,'String'));
METH=2;
[R,N1] = findR(S,Y,U,METH);
[A,C,B,D,K] = sident(METH,1,S,N,1,R);
SYS1=syslin(1,A,B,C,D);
SYS1.X0 = inistate(SYS1,Y,U);

Y1=flts(U',SYS1);
plot2d(t,[Y,Y1'])
s = %s;
Gz = ss2tf(SYS1);
Ts = eval(get(handles.edit_Ts,'String'));
Gs = horner(Gz, (1 + s*Ts/2)/(1 - s*Ts/2) )

Gsdenom = coeff(Gs.den);
clean_tol = Gsdenom(N+1)*0.9;

Gs2 = clean(Gs,clean_tol)

Gs2.num = Gs2.num/Gsdenom(N+1);
Gs2.den = Gs2.den/Gsdenom(N+1);
Gs2temp = Gs2;
Gs2temp.num = round(Gs2temp.num*1000)/1000;
Gs2temp.den = round(Gs2temp.den*1000)/1000;
//Gs2str = prettyprint(Gs2temp);

Gz2 = ss2tf(dscr(Gs2,Ts));
Gz2temp = Gz2;
Gz2temp.num = round(Gz2temp.num*100000)/100000;
Gz2temp.den = round(Gz2temp.den*100000)/100000;
//Gz2str = prettyprint(Gz2temp);

set(handles.txt_Result1,'String',[pol2str(Gz2temp.num),pol2str(Gz2temp.den)]);
set(handles.txt_Result2,'String',[pol2str(Gs2temp.num),pol2str(Gs2temp.den)]);
handles.Gs2 = Gs2;
handles.Gz2 = Gz2;
[handles] = resume(handles);

endfunction

function pb_Export_callback(handles)
//Write your callback for  pb_Output  here
disp(handles.Gs2);
disp(handles.Gz2);
endfunction

